----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    14:07:47 10/07/2013 
-- Design Name: 
-- Module Name:    TCPIP_if - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;
use IEEE.std_logic_misc.all;
use IEEE.numeric_std.all;
use work.amc13_pack.all;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
library UNISIM;
use UNISIM.VComponents.all;
Library UNIMACRO;
use UNIMACRO.vcomponents.all;

entity DAQLSCXG_if is
    Port ( sysclk : in  STD_LOGIC;
           clk125 : in  STD_LOGIC;
           DRPclk : in  STD_LOGIC;
           reset : in  STD_LOGIC;
           daq_reset : in  STD_LOGIC;
           gtx_reset : in  STD_LOGIC;
           rstCntr : in  STD_LOGIC;
           Dis_pd : in  STD_LOGIC;
           test : in  STD_LOGIC;
					 enSFP : IN std_logic_vector(3 downto 0);
					 SFP_ABS : IN std_logic_vector(1 downto 0);
					 LSC_ID : IN std_logic_vector(15 downto 0);
					 SFP_down : OUT std_logic_vector(2 downto 0);
           inc_ddr_pa : in  STD_LOGIC;
-- event data in
					 evt_data_rdy : in std_logic_vector(2 downto 0);
					 EventData_in : in array3X67;
					 EventData_we : in   std_logic_VECTOR(2 downto 0);
					 EventData_re : out   std_logic_VECTOR(2 downto 0); -- 
					 evt_buf_full : out std_logic_vector(2 downto 0);
					 buf_rqst : in std_logic_vector(3 downto 0);
           MonBufOverWrite : in  STD_LOGIC;
           MonBuf_avl : out  STD_LOGIC;
           MonBuf_empty : out  STD_LOGIC;
           MonBufOvfl : out  STD_LOGIC;
					 mon_evt_cnt : out std_logic_vector(31 downto 0);
					 WrtMonBufDone : in  STD_LOGIC_VECTOR(2 downto 0);
-- ddr wportA status
					 wport_rdy : in std_logic_vector(2 downto 0);
					 wport_FIFO_full : in std_logic_vector(2 downto 0);
-- signal to ddr_if, AMC_if to start moving data
					 EventBufAddr_we : out std_logic_VECTOR(2 downto 0);
					 EventBufAddr : out array3X14;
-- SFP ports
           SFP0_RXN : in  STD_LOGIC;
           SFP0_RXP : in  STD_LOGIC;
           SFP1_RXN : in  STD_LOGIC;
           SFP1_RXP : in  STD_LOGIC;
           SFP0_TXN : out  STD_LOGIC;
           SFP0_TXP : out  STD_LOGIC;
           SFP1_TXN : out  STD_LOGIC;
           SFP1_TXP : out  STD_LOGIC;
           SFP_REFCLK : in  STD_LOGIC;
--	ipbus signals
					 ipb_clk : in  STD_LOGIC;
					 ipb_write : in  STD_LOGIC;
					 ipb_strobe : in  STD_LOGIC;
					 ipb_addr	: in  STD_LOGIC_VECTOR(31 downto 0);
					 ipb_wdata : in  STD_LOGIC_VECTOR(31 downto 0);
					 ipb_rdata : out  STD_LOGIC_VECTOR(31 downto 0);
					 ipb_ack : out  STD_LOGIC
					 );
end DAQLSCXG_if;

architecture Behavioral of DAQLSCXG_if is
COMPONENT DaqLSCXG
    Port ( sys_reset : in  STD_LOGIC; -- active high reset of all logic but GTX
           sys_clk : in  STD_LOGIC;
           sfp_pd : in array2x2;
           DRP_clk : in  STD_LOGIC;
           LinkWe : in  STD_LOGIC_VECTOR (1 downto 0);
           LinkCtrl : in  STD_LOGIC_VECTOR (1 downto 0);
           LinkData : in  array2x64;
           srcID : in array2x16;
           LinkDown : out  STD_LOGIC_VECTOR (1 downto 0);
           LinkFull : out  STD_LOGIC_VECTOR (1 downto 0);
			  --
			  sync_loss : out STD_LOGIC_VECTOR (1 downto 0);		  -- goes to '1' (rxusrclk) when SERDES is out of synch
			  status_ce : in std_logic_VECTOR (1 downto 0);        -- not implemented yet
			  status_addr : in STD_LOGIC_VECTOR (15 downto 0); -- not implemented yet
			  status_port : out array2x64; -- first 32 bits are hard-wired
			  --
			  txusrclk_o : out STD_LOGIC;  -- reconstructed tx clock, to be used to clock sending circuitry
			  rxusrclk_o : out STD_LOGIC;  -- reconstructed rx clock, to be used to clock receiving circuitry
			  --
			  gtx_reset : in std_logic;    -- full reset of GTX only
			  gtx_refclk : in std_logic; -- iob for refclk neg
			  sfp_rxn : in std_logic_VECTOR (1 downto 0);      -- sfp iobs
			  sfp_rxp : in std_logic_VECTOR (1 downto 0);
			  sfp_txn : out std_logic_VECTOR (1 downto 0);
			  sfp_txp : out std_logic_VECTOR (1 downto 0)
			 );
END COMPONENT;
COMPONENT cmsCRC64
	PORT(
		clk : IN std_logic;
		reset : IN std_logic;
		crc_init : IN std_logic;
		trailer : IN std_logic;
		crc_d : IN std_logic_vector(63 downto 0);
		crc_ce : IN std_logic;          
		crc : OUT std_logic_vector(15 downto 0);
		crc_err : OUT std_logic;
		dout : OUT std_logic_vector(63 downto 0);
		dout_vld : OUT std_logic
		);
END COMPONENT;
function A_GT_B (A, B : std_logic_vector(10 downto 0)) return boolean is
variable tmp : std_logic_vector(10 downto 0);
begin
	tmp := A - B;
	if(tmp(10) = '0' and or_reduce(tmp(9 downto 0)) = '1')then
		return true;
	else
		return false;
	end if;
end A_GT_B;
function A_GE_B (A, B : std_logic_vector(10 downto 0)) return boolean is
variable tmp : std_logic_vector(10 downto 0);
begin
	tmp := A - B;
	if(tmp(10) = '0')then
		return true;
	else
		return false;
	end if;
end A_GE_B;
signal resetSyncRegs : std_logic_vector(2 downto 0) := (others => '0');
signal daq_resetSyncRegs : std_logic_vector(2 downto 0) := (others => '0');
signal inc_ddr_paSyncRegs : std_logic_vector(3 downto 0) := (others => '0');
signal bldr2SFP_sel : array3X2 := (others => (others => '0'));
signal SFP2bldr_sel : array3X2 := (others => (others => '0'));
signal EventBufAddr_we_i : std_logic_vector(2 downto 0) := (others => '0');
signal ReadBusy : std_logic_vector(1 downto 0) := (others => '0');
signal sysDIV2 : std_logic := '0';
signal MonBuf_avl_i : std_logic := '0';
signal MonBufAbort : std_logic := '0';
signal GotLastBlock : std_logic := '0';
signal MonBuf_wa : std_logic_vector(10 downto 0) := (others => '0');
signal StartMonBuf_wa : std_logic_vector(10 downto 0) := (others => '0');
signal MonBuf_ra : std_logic_vector(10 downto 0) := (others => '0');
signal MonBufUsed : std_logic_vector(9 downto 0) := (others => '0');
signal NXT_MonBuf : array3X11 := (others => (others => '0'));
signal Written_MonBuf : array4X11 := (others => (others => '0'));
signal Written_MonBufMatch : std_logic_vector(2 downto 0) := (others => '0');
signal AddrOffset : array3X10 := (others => (others => '0'));
signal header : std_logic_vector(1 downto 0) := (others => '0');
signal header_q : std_logic_vector(1 downto 0) := (others => '0');
signal sfp_rxn : std_logic_vector(1 downto 0) := (others => '0');
signal sfp_rxp : std_logic_vector(1 downto 0) := (others => '0');
signal sfp_txn : std_logic_vector(1 downto 0) := (others => '0');
signal sfp_txp : std_logic_vector(1 downto 0) := (others => '0');
signal sync_loss : std_logic_vector(1 downto 0) := (others => '0');
signal LinkFull_n : std_logic_vector(1 downto 0) := (others => '0');
signal LinkFull : std_logic_vector(2 downto 0) := (others => '0');
signal LinkCtrl : std_logic_vector(1 downto 0) := (others => '0');
signal LinkWe : std_logic_vector(1 downto 0) := (others => '0');
signal LinkDown : std_logic_vector(1 downto 0) := (others => '0');
signal DaqLSC_status : array2x64 := (others => (others => '0'));
signal LinkData : array2x65 := (others => (others => '0'));
signal sync_loss_cntr : array2x32 := (others => (others => '0'));
signal bldr_evt_cntr : array2x32 := (others => (others => '0'));
signal bldr_blk_cntr : array2x32 := (others => (others => '0'));
signal bldr_word_cntr : array2x32 := (others => (others => '0'));
signal event_cntr : array2x32 := (others => (others => '0'));
signal word_cntr : array2x32 := (others => (others => '0'));
signal EventBufAddr_we_cntr : array2x32 := (others => (others => '0'));
signal src_ID : array2x16 := (others => (others => '0'));
signal txusrclk : std_logic := '0';
signal LinkDatap : array2x64 := (others => (others => '0'));
signal sfp_pd : array2x2 := (others => (others => '0'));
signal MonBufOvfl_i : std_logic := '0';
signal EndMonBuf_wa_we : std_logic := '0';
signal EndMonBuf_wa_re : std_logic := '0';
signal EndMonBuf_wa_o : std_logic_vector(10 downto 0) := (others => '0');
signal WrittenMonBuf_wa : std_logic_vector(10 downto 0) := (others => '0');
signal EndMonBuf_wa_a : std_logic_vector(4 downto 0) := (others => '0');
signal mon_evt_cnt_i : std_logic_vector(10 downto 0) := (others => '0');
signal status_addr : std_logic_vector(15 downto 0) := (others => '0');
signal cmsCRC_initp : std_logic_vector(2 downto 0) := (others => '0');
signal cmsCRC_init : std_logic_vector(2 downto 0) := (others => '0');
signal cmsCRC_err : std_logic_vector(2 downto 0) := (others => '0');
signal cmsCRC_errCntr : array3X32 := (others => (others => '0'));
signal EvtLength_err : std_logic_vector(2 downto 0) := (others => '0');
signal TotalEvtLengthCntr24q : std_logic_vector(2 downto 0) := (others => '0');
signal EvtLengthCntr : array3X24 := (others => (others => '0'));
signal EvtLength_errCntr : array3X32 := (others => (others => '0'));
signal TotalEvtLengthCntr : array3X56 := (others => (others => '0'));
signal StopOverWrite : std_logic := '0';
component chipscope1 is
		generic (N : integer := 5);
    Port ( clk : in  STD_LOGIC;
           Din : in  STD_LOGIC_VECTOR (303 downto 0));
end component;
signal cs : std_logic_vector(303 downto 0) := (others => '0');
begin
MonBuf_avl <= MonBuf_avl_i;
MonBufOvfl <= MonBufOvfl_i;
EventBufAddr_we <= EventBufAddr_we_i;
mon_evt_cnt(31 downto 11) <= (others => '0');
mon_evt_cnt(10 downto 0) <= mon_evt_cnt_i;
ipb_ack <= '0';
--sfp_pd(0) <= "00" when Dis_pd = '1' else "11" when enSFP(3) = '1' or enSFP(0) = '0' else "00";
--sfp_pd(1) <= "00" when Dis_pd = '1' else "11" when enSFP(3) = '1' or enSFP(1) = '0' else "00";
sfp_pd(0) <= "00" when Dis_pd = '1' or SFP_ABS(0) = '0' else "11";
sfp_pd(1) <= "00" when Dis_pd = '1' or SFP_ABS(1) = '0' else "11";
EventBufAddr_we(2) <= '0';
EventBufAddr(2) <= (others => '0');
evt_buf_full(2) <= '1';
EventData_re(2) <= '0';
SFP_down(2) <= '0';
SFP_down(1) <= not LinkDown(1) and not enSFP(3) and enSFP(1);
SFP_down(0) <= not LinkDown(0) and not enSFP(3) and enSFP(0);
LinkFull(2) <= '0';
LinkFull(1) <= not LinkFull_n(1) and not enSFP(3) and enSFP(1);
LinkFull(0) <= not LinkFull_n(0) and not enSFP(3) and enSFP(0);
i_DaqLSCXG: DaqLSCXG PORT MAP(
		sys_reset => daq_resetSyncRegs(2),
		sys_clk => sysclk,
		sfp_pd => sfp_pd,
		DRP_clk => DRPclk,
		LinkWe => LinkWe,
		LinkCtrl => LinkCtrl,
		LinkData => LinkDatap,
		srcID => src_ID,
		LinkDown => LinkDown,
		LinkFull => LinkFull_n,
		sync_loss => sync_loss,
		status_ce => "00",
		status_addr => status_addr,
		status_port => DaqLSC_status,
		txusrclk_o => txusrclk,
		rxusrclk_o => open,
		gtx_reset => gtx_reset,
		gtx_refclk => SFP_REFCLK,
		sfp_rxn => sfp_rxn,
		sfp_rxp => sfp_rxp,
		sfp_txn => sfp_txn,
		sfp_txp => sfp_txp
	);
status_addr <= x"000" & ipb_addr(3 downto 0);
LinkDatap(0) <= LinkData(0)(63 downto 0);
LinkDatap(1) <= LinkData(1)(63 downto 0);
--LinkDatap(2) <= LinkData(2)(63 downto 0);
src_ID(0) <= LSC_ID(15 downto 2) & "00";
src_ID(1) <= LSC_ID(15 downto 2) & "01";
--src_ID(2) <= LSC_ID(15 downto 2) & "10";
sfp_rxn(0) <= SFP0_RXN;
sfp_rxp(0) <= SFP0_RXP;
SFP0_TXN <= sfp_txn(0);
SFP0_TXP <= sfp_txp(0);
sfp_rxn(1) <= SFP1_RXN;
sfp_rxp(1) <= SFP1_RXP;
SFP1_TXN <= sfp_txn(1);
SFP1_TXP <= sfp_txp(1);
--sfp_rxn(2) <= SFP2_RXN;
--sfp_rxp(2) <= SFP2_RXP;
--SFP2_TXN <= sfp_txn(2);
--SFP2_TXP <= sfp_txp(2);
process(sysclk,daq_reset)
begin
	if(daq_reset = '1')then
		daq_resetSyncRegs <= (others => '1');
	elsif(sysclk'event and sysclk = '1')then
		daq_resetSyncRegs <= daq_resetSyncRegs(1 downto 0) & '0';
	end if;
end process;
process(sysclk,reset)
begin
	if(reset = '1')then
		resetSyncRegs <= (others => '1');
	elsif(sysclk'event and sysclk = '1')then
		resetSyncRegs <= resetSyncRegs(1 downto 0) & '0';
	end if;
end process;
g_EndMonBuf_wa: for i in 0 to 10 generate
  i_EndMonBuf_wa : SRLC32E
   port map (
      Q => EndMonBuf_wa_o(i),        -- SRL data output
      Q31 => open,    -- SRL cascade output pin
      A => EndMonBuf_wa_a,        -- 5-bit shift depth select input
      CE => EndMonBuf_wa_we,      -- Clock enable input
      CLK => sysclk,    -- Clock input
      D => MonBuf_wa(i)         -- SRL data input
   );
end generate;
process(sysclk)
begin
	if(sysclk'event and sysclk = '1')then
		if(MonBufOvfl_i = '1' or (MonBuf_wa(10) /= MonBuf_ra(10) and MonBuf_wa(9 downto 0) = MonBuf_ra(9 downto 0)))then
			MonBuf_avl_i <= '0';
		else
			MonBuf_avl_i <= '1';
		end if;
		if(MonBufOverWrite = '1')then
			mon_evt_cnt_i <= '0' & WrittenMonBuf_wa(9 downto 0);
		else
			mon_evt_cnt_i <= WrittenMonBuf_wa - MonBuf_ra;
		end if;
--		mon_evt_cnt_i <= WrittenMonBuf_wa - MonBuf_ra;
		MonBuf_empty <= not or_reduce(mon_evt_cnt_i);
		if(resetSyncRegs(2) = '1')then
			ReadBusy <= (others => '0');
			EventData_re <= (others => '0');
			EventBufAddr_we_i <= (others => '0');
			StartMonBuf_wa <= (others => '0');
			EndMonBuf_wa_a <= (others => '1');
			MonBuf_wa <= (others => '0');
			WrittenMonBuf_wa <= (others => '0');
			MonBuf_ra <= (others => '0');
			MonBufUsed <= (others => '0');
			Written_MonBufMatch <= (others => '1');
			Written_MonBuf <= (others => (others => '0'));
			NXT_MonBuf <= (others => (others => '0'));
			inc_ddr_paSyncRegs <= (others => '0');
			GotLastBlock <= '0';
			MonBufAbort <= '0';
			EndMonBuf_wa_we <= '0';
			EndMonBuf_wa_re <= '0';
			MonBufOvfl_i <= '0';
		else
			for i in 0 to 1 loop
				if(EVENTdata_in(i)(64) = '1' and EVENTdata_we(i) = '1')then
					ReadBusy(i) <= '0';
				elsif(evt_data_rdy(i) = '1' and wport_rdy(i) = '1')then
					ReadBusy(i) <= '1';
				end if;
				EventData_re(i) <= evt_data_rdy(i) and wport_rdy(i) and not ReadBusy(i);
				if(EventData_in(i)(66) = '0' and evt_data_rdy(i) = '1' and wport_rdy(i) = '1' and ReadBusy(i) = '0')then
					EventBufAddr_we_i(i) <= '1';
				else
					EventBufAddr_we_i(i) <= '0';
				end if;
			end loop;
			if(buf_rqst(0) = '1' and MonBuf_avl_i = '0')then
				MonBufOvfl_i <= '1';
			elsif(MonBufAbort = '1')then
				MonBufOvfl_i <= '0';
			end if;
			if(MonBufOvfl_i = '0' or MonBufAbort = '1')then
				GotLastBlock <= '0';
			elsif(buf_rqst(3) = '1')then
				GotLastBlock <= '1';
			end if;
			if(MonBufAbort = '0' and Written_MonBuf(3) = MonBuf_wa and GotLastBlock = '1')then
				MonBufAbort <= '1';
			else
				MonBufAbort <= '0';
			end if;
			if(EndMonBuf_wa_we = '1' and EndMonBuf_wa_re = '0')then
				EndMonBuf_wa_a <= EndMonBuf_wa_a + 1;
			elsif(EndMonBuf_wa_we = '0' and EndMonBuf_wa_re = '1')then
				EndMonBuf_wa_a <= EndMonBuf_wa_a - 1;
			end if;
			EndMonBuf_wa_we <= buf_rqst(3) and buf_rqst(0) and MonBuf_avl_i;
			if(Written_MonBuf(3) = EndMonBuf_wa_o and EndMonBuf_wa_re = '0' and and_reduce(EndMonBuf_wa_a) = '0')then
				EndMonBuf_wa_re <= '1';
			else
				EndMonBuf_wa_re <= '0';
			end if;
			if(EndMonBuf_wa_re = '1')then
				WrittenMonBuf_wa <= EndMonBuf_wa_o;
			end if;
			if(buf_rqst(2) = '1' and buf_rqst(0) = '1' and MonBuf_avl_i = '1')then
				StartMonBuf_wa <= MonBuf_wa;
			end if;
			if(MonBufAbort = '1')then
				MonBuf_wa <= StartMonBuf_wa;
			elsif(buf_rqst(0) = '1' and MonBuf_avl_i = '1')then
				MonBuf_wa <= MonBuf_wa + 1;
			end if;
			MonBufUsed <= MonBuf_wa(9 downto 0) - MonBuf_ra(9 downto 0);
--			if(MonBufOverWrite = '1' and and_induce(MonBufUsed) = '1' and buf_rqst(0) = '1')then
--        inc_MonBuf_ra <= '1';
--			else
--        inc_MonBuf_ra <= '0';
--			end if;
--			if(inc_ddr_paSyncRegs(3 downto 2) = "10" or inc_MonBuf_ra = '1')then
			if(inc_ddr_paSyncRegs(3 downto 2) = "10" or (MonBufOverWrite = '1' and StopOverWrite = '0' and and_reduce(MonBufUsed) = '1' and buf_rqst(0) = '1'))then
				MonBuf_ra <= MonBuf_ra + 1;
			end if;
			if(Written_MonBuf(0) = Written_MonBuf(3))then
				Written_MonBufMatch(0) <= '1';
			else
				Written_MonBufMatch(0) <= '0';
			end if;
			if((EnSFP(2 downto 0) = "111" or EnSFP(2 downto 0) = "011" or EnSFP(2 downto 0) = "110" or EnSFP(2 downto 0) = "101") and Written_MonBuf(1) = Written_MonBuf(3))then
				Written_MonBufMatch(1) <= '1';
			else
				Written_MonBufMatch(1) <= '0';
			end if;
			if(EnSFP(2 downto 0) = "111" and Written_MonBuf(2) = Written_MonBuf(3))then
				Written_MonBufMatch(2) <= '1';
			else
				Written_MonBufMatch(2) <= '0';
			end if;
			if(Written_MonBufMatch = "000" and sysDIV2 = '0')then
				Written_MonBuf(3) <= Written_MonBuf(3) + 1;
			end if;
			for i in 0 to 1 loop
				if(MonBufAbort = '1')then
					NXT_MonBuf(i) <= StartMonBuf_wa;
				elsif(EventBufAddr_we_i(i) = '1' and EventData_in(i)(66) = '0')then
					NXT_MonBuf(i) <= NXT_MonBuf(i) + 1;
				end if;
				if(MonBufAbort = '1')then
					Written_MonBuf(i) <= StartMonBuf_wa;
				elsif(WrtMonBufDone(i) = '1')then
					Written_MonBuf(i) <= Written_MonBuf(i) + 1;
				end if;
			end loop;
			inc_ddr_paSyncRegs <= inc_ddr_paSyncRegs(2 downto 0) & inc_ddr_pa;
		end if;
		case EnSFP(1 downto 0) is
--			when "011" | "101" | "110" => AddrOffset(0)(9 downto 6) <= x"8";
			when "11" => AddrOffset(0)(9 downto 6) <= x"8";
--			when "111" => AddrOffset(0)(9 downto 6) <= x"5";
			when others => AddrOffset(0)(9 downto 6) <= x"0";
		end case;
		AddrOffset(1)(9 downto 6) <= x"0";
--		AddrOffset(2)(9 downto 6) <= x"a";
		for i in 0 to 1 loop
			EventBufAddr(i) <= NXT_MonBuf(i)(9 downto 0) & AddrOffset(i)(9 downto 6);
		end loop;
	end if;
end process;
process(sysclk)
begin
	if(sysclk'event and sysclk = '1')then
		sysDIV2 <= not sysDIV2;
		for i in 0 to 1 loop
			if(resetSyncRegs(2) = '1')then
				header(i) <= '1';
				header_q(i) <= '0';
			elsif(EventData_we(i) = '1')then
				header(i) <= EventData_in(i)(65) or (header(i) and not header_q(i));
				header_q(i) <= header(i);
			end if;
		end loop;
		if(EnSFP(1 downto 0) = "01")then
			LinkData(0) <= EventData_in(0)(65) & EventData_in(0)(63 downto 0);
			LinkCtrl(0) <= not(header(0) or EventData_in(0)(65));
			LinkWe(0) <= EventData_we(0) and not EnSFP(3);
		else
			LinkData(0) <= EventData_in(1)(65) & EventData_in(1)(63 downto 0);
			LinkCtrl(0) <= not(header(1) or EventData_in(1)(65));
			LinkWe(0) <= EventData_we(1) and EnSFP(0) and not EnSFP(3);
		end if;
--		if(EnSFP(2 downto 0) = "110")then1
--			LinkData(1) <= EventData_in(1)(65) & EventData_in(1)(63 downto 0);
--			LinkCtrl(1) <= not(header(1) or EventData_in(1)(65));
--			LinkWe(1) <= EventData_we(1) and not EnSFP(3);
--		else
		LinkData(1) <= EventData_in(0)(65) & EventData_in(0)(63 downto 0);
		LinkCtrl(1) <= not(header(0) or EventData_in(0)(65));
		LinkWe(1) <= EventData_we(0) and EnSFP(1) and not EnSFP(3);
--		end if;
--		if(EnSFP(2 downto 0) = "111")then
--			LinkData(2) <= EventData_in(2)(65) & EventData_in(2)(63 downto 0);
--			LinkCtrl(2) <= not(header(2) or EventData_in(2)(65));
--			LinkWe(2) <= EventData_we(2) and not EnSFP(3);
--		else
--			LinkData(2) <= EventData_in(0)(65) & EventData_in(0)(63 downto 0);
--			LinkCtrl(2) <= not(header(0) or EventData_in(0)(65));
--			LinkWe(2) <= EventData_we(0) and EnSFP(2) and not EnSFP(3);
--		end if;
--		case EnSFP(2 downto 0) is
--			when "010" | "011" | "111" => SFP2bldr_sel(0) <= "01";
--			when "100" | "101" | "110" => SFP2bldr_sel(0) <= "10";
--			when others => SFP2bldr_sel(0) <= "00";
--		end case;
--		case EnSFP(2 downto 0) is
--			when "010" | "011" | "101" | "111" => SFP2bldr_sel(1) <= "00";
--			when others => SFP2bldr_sel(1) <= "01";
--		end case;
--		case EnSFP(2 downto 0) is
--			when "100" | "110" => SFP2bldr_sel(2) <= "00";
--			when "101" => SFP2bldr_sel(2) <= "01";
--			when others => SFP2bldr_sel(2) <= "10";
--		end case;
--		evt_buf_full(0) <= (not LinkFull_n(conv_integer(SFP2bldr_sel(0))) and EnSFP(conv_integer(SFP2bldr_sel(0))) and not EnSFP(3)) or wport_FIFO_full(0);
--		if(SFP2bldr_sel(1)(0) = '0')then
--			evt_buf_full(1) <= (not LinkFull_n(0) and EnSFP(0) and not EnSFP(3)) or wport_FIFO_full(1);
--		else
--			evt_buf_full(1) <= (not LinkFull_n(1) and EnSFP(1) and not EnSFP(3)) or wport_FIFO_full(1);
--		end if;
--		evt_buf_full(2) <= (not LinkFull_n(conv_integer(SFP2bldr_sel(2))) and EnSFP(conv_integer(SFP2bldr_sel(2))) and not EnSFP(3))  or wport_FIFO_full(2);
		if(EnSFP(0) = '1')then
			evt_buf_full(0) <= (not LinkFull_n(0) and not EnSFP(3)) or wport_FIFO_full(0);
		else
			evt_buf_full(0) <= (not LinkFull_n(1) and not EnSFP(3)) or wport_FIFO_full(0);
		end if;
		evt_buf_full(1) <= (not LinkFull_n(0) and not EnSFP(3)) or wport_FIFO_full(1);
	end if;
end process;
process(txusrclk,rstCntr)
begin
	if(rstCntr = '1')then
		sync_loss_cntr <= (others => (others => '0'));
	elsif(txusrclk'event and txusrclk = '1')then
		for i in 0 to 1 loop
			if(sync_loss(i) = '1')then
				sync_loss_cntr(i) <= sync_loss_cntr(i) + 1;
			end if;
		end loop;
	end if;
end process;
process(sysclk,rstCntr)
begin
	if(rstCntr = '1')then
		cmsCRC_errCntr <= (others => (others => '0'));
		EvtLength_errCntr <= (others => (others => '0'));
		EvtLength_err <= "000";
		StopOverWrite <= '0';
	elsif(sysclk'event and sysclk = '1')then
		for i in 0 to 1 loop
			if(cmsCRC_err(i) = '1')then
        cmsCRC_errCntr(i) <= cmsCRC_errCntr(i) + 1;
      end if;
			if(EventData_we(i) = '1' and EventData_in(i)(65) = '1' and EventData_in(i)(55 downto 32) /= EvtLengthCntr(i))then
				EvtLength_err(i) <= '1';
			else
				EvtLength_err(i) <= '0';
			end if;
			if(EvtLength_err(i) = '1')then
				EvtLength_errCntr(i) <= EvtLength_errCntr(i) + 1;
			end if;
		end loop;
		if(or_reduce(cmsCRC_err) = '1' or or_reduce(EvtLength_err) = '1')then
		  StopOverWrite <= '1';
		end if;
	end if;
end process;
process(ipb_addr)
begin
	if(ipb_addr(15 downto 7) = LSC_addr(15 downto 7))then
		case ipb_addr(6 downto 4) is
			when "000" =>
              ipb_rdata <= DaqLSC_status(0)(31 downto 0);
			when "001" =>
              ipb_rdata <= DaqLSC_status(1)(31 downto 0);
			when "011" =>
			  case ipb_addr(3 downto 0) is
					when x"0" => ipb_rdata <= sync_loss_cntr(0);
					when x"1" => ipb_rdata <= sync_loss_cntr(1);
					when x"3" => ipb_rdata <= cmsCRC_errCntr(0);
					when x"4" => ipb_rdata <= cmsCRC_errCntr(1);
					when x"6" => ipb_rdata <= EvtLength_errCntr(0);
					when x"7" => ipb_rdata <= EvtLength_errCntr(1);
					when x"a" => ipb_rdata <= TotalEvtLengthCntr(0)(31 downto 0);
					when x"b" => ipb_rdata <= x"00" & TotalEvtLengthCntr(0)(55 downto 32);
					when x"c" => ipb_rdata <= TotalEvtLengthCntr(1)(31 downto 0);
					when x"d" => ipb_rdata <= x"00" & TotalEvtLengthCntr(1)(55 downto 32);
					when others => ipb_rdata <= (others => '0');
        end case;
			when "100" =>
				case ipb_addr(3 downto 0) is
					when x"0" => ipb_rdata <= bldr_evt_cntr(0);
					when x"1" => ipb_rdata <= bldr_evt_cntr(1);
					when x"4" => ipb_rdata <= bldr_word_cntr(0);
					when x"5" => ipb_rdata <= bldr_word_cntr(1);
					when x"8" => ipb_rdata <= bldr_blk_cntr(0);
					when x"9" => ipb_rdata <= bldr_blk_cntr(1);
					when others => ipb_rdata <= (others => '0');
				end case;
			when "101" =>
				case ipb_addr(3 downto 0) is
					when x"1" => ipb_rdata <= "000" & EndMonBuf_wa_a & '0' & EndMonBuf_wa_o & '0' & WrittenMonBuf_wa;
					when x"2" => ipb_rdata <= "00000" & NXT_MonBuf(1) & "00000" & NXT_MonBuf(0);
					when x"3" => ipb_rdata <= "00000" & MonBuf_wa & x"0000";
					when x"4" => ipb_rdata <= x"00" & "00" & header & '0' & LinkFull & "00" & ReadBusy & '0' & evt_data_rdy & '0' & wport_FIFO_full & '0' & wport_rdy;
					when x"5" => ipb_rdata <= event_cntr(0);
					when x"6" => ipb_rdata <= event_cntr(1);
					when x"8" => ipb_rdata <= word_cntr(0);
					when x"9" => ipb_rdata <= word_cntr(1);
					when x"b" => ipb_rdata <= EventBufAddr_we_cntr(0);
					when x"c" => ipb_rdata <= EventBufAddr_we_cntr(1);
					when others => ipb_rdata <= (others => '0');
				end case;
			when others => ipb_rdata <= (others => '0');
		end case;
	else
		ipb_rdata <= (others => '0');
	end if;
end process;
g_cmsCRC : for i in 0 to 1 generate
 i_cmsCRC: cmsCRC64 PORT MAP(
		clk => sysclk,
		reset => '0',
		crc_init => cmsCRC_init(i),
		trailer => LinkData(i)(64),
		crc_d => LinkData(i)(63 downto 0),
		crc_ce => LinkWe(i),
		crc => open,
		crc_err => cmsCRC_err(i),
		dout => open,
		dout_vld => open
	);
end generate;
process(sysclk)
begin
	if(sysclk'event and sysclk = '1')then
		if(resetSyncRegs(2) = '1')then
			cmsCRC_initp <= "000";
			cmsCRC_init <= "111";
			bldr_blk_cntr <= (others => (others => '0'));
			bldr_evt_cntr <= (others => (others => '0'));
			bldr_word_cntr <= (others => (others => '0'));
			event_cntr <= (others => (others => '0'));
			word_cntr <= (others => (others => '0'));
			EventBufAddr_we_cntr <= (others => (others => '0'));
			EvtLengthCntr <= (others => x"000001");
			TotalEvtLengthCntr <= (others => (others => '0'));
			TotalEvtLengthCntr24q <= "000";
		else
			for i in 0 to 1 loop
				cmsCRC_initp(i) <= LinkData(i)(64) and LinkWe(i);
				if(LinkWe(i) = '1')then
					word_cntr(i) <= word_cntr(i) + 1;
				end if;
				if(LinkWe(i) = '1' and LinkData(i)(64) = '1')then
					event_cntr(i) <= event_cntr(i) + 1;
				end if;
				if(EventData_we(i) = '1' and EventData_in(i)(64) = '1')then
					bldr_blk_cntr(i) <= bldr_blk_cntr(i) + 1;
				end if;
				if(EventData_we(i) = '1' and EventData_in(i)(65) = '1')then
					bldr_evt_cntr(i) <= bldr_evt_cntr(i) + 1;
				end if;
				if(EventData_we(i) = '1')then
					bldr_word_cntr(i) <= bldr_word_cntr(i) + 1;
				end if;
				if(EventBufAddr_we_i(i) = '1')then
					EventBufAddr_we_cntr(i) <= EventBufAddr_we_cntr(i) + 1;
				end if;
				if(EventData_we(i) = '1')then
					if(EventData_in(i)(65) = '1')then
						EvtLengthCntr(i) <= x"000001";
						TotalEvtLengthCntr(i)(24 downto 0) <= TotalEvtLengthCntr(i)(24 downto 0) + ('0' & EventData_in(i)(55 downto 32));
					else
						EvtLengthCntr(i) <= EvtLengthCntr(i) + 1;
					end if;
				end if;
				TotalEvtLengthCntr24q(i) <= TotalEvtLengthCntr(i)(24);
				if(TotalEvtLengthCntr24q(i) = '1' and TotalEvtLengthCntr(i)(24) = '0')then
					TotalEvtLengthCntr(i)(55 downto 25) <= TotalEvtLengthCntr(i)(55 downto 25) + 1;
				end if;
			end loop;
			cmsCRC_init <= cmsCRC_initp;
		end if;
	end if;
end process;
end Behavioral;

